"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var CollectorActions;
(function (CollectorActions) {
    CollectorActions["animation"] = "animation";
    CollectorActions["wait"] = "wait";
})(CollectorActions = exports.CollectorActions || (exports.CollectorActions = {}));
exports.CollectorContext = React.createContext(undefined);
var Collector = function (_a) {
    var children = _a.children, style = _a.style, className = _a.className, data = _a.data, receiveRenderChildren = _a.receiveRenderChildren, receiveRef = _a.receiveRef, receiveData = _a.receiveData, topMostCollector = _a.topMostCollector, receiveFocalTargetRef = _a.receiveFocalTargetRef;
    if (typeof children !== 'function') {
        return (React.createElement(exports.CollectorContext.Consumer, null, function (collect) { return (React.createElement(exports.CollectorContext.Provider, { value: {
                ref: function (ref) {
                    if (receiveRef) {
                        receiveRef(ref);
                    }
                    if (!topMostCollector && collect) {
                        collect.ref(ref);
                    }
                },
                focalTargetRef: function (ref) {
                    if (receiveFocalTargetRef) {
                        receiveFocalTargetRef(ref);
                    }
                    if (!topMostCollector && collect) {
                        collect.focalTargetRef(ref);
                    }
                },
                data: function (childData) {
                    var collectedData = data ? [data].concat(childData) : childData;
                    if (!topMostCollector && collect) {
                        collect.data(collectedData);
                    }
                    if (receiveData) {
                        receiveData(childData);
                    }
                },
                renderChildren: function (node) {
                    if (!topMostCollector && collect) {
                        collect.renderChildren(node);
                    }
                    if (receiveRenderChildren) {
                        receiveRenderChildren(node);
                    }
                },
                style: __assign({}, style, (collect && !topMostCollector ? collect.style : {})),
                className: className || (collect && !topMostCollector ? collect.className : undefined),
            } }, children)); }));
    }
    return (React.createElement(exports.CollectorContext.Consumer, null, function (collect) {
        if (typeof children === 'function') {
            if (!topMostCollector && collect) {
                var collectedData = data ? [data] : [];
                collect.renderChildren(children);
                collect.data(collectedData);
            }
            if (receiveRenderChildren) {
                receiveRenderChildren(children);
            }
            return React.Children.only(children({
                className: className || (collect && !topMostCollector ? collect.className : undefined),
                ref: function (ref) {
                    if (!topMostCollector && collect) {
                        collect.ref(ref);
                    }
                    if (receiveRef) {
                        receiveRef(ref);
                    }
                },
                style: collect && !topMostCollector ? __assign({}, style, collect.style) : style || {},
            }));
        }
        return null;
    }));
};
exports.default = Collector;
//# sourceMappingURL=index.js.map