"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
exports.AnimatorContext = React.createContext(undefined);
var VisibilityManager = /** @class */ (function (_super) {
    __extends(VisibilityManager, _super);
    function VisibilityManager() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            style: {
                visibility: _this.props.isInitiallyVisible ? 'visible' : 'hidden',
            },
        };
        _this.onStart = function (opts) {
            var _a = _this.props, context = _a.context, name = _a.name;
            if (context && context.onFinish) {
                context.onStart(opts);
            }
            if (name && opts.name !== name) {
                return;
            }
            if (_this.state.style.visibility === 'visible') {
                _this.setState({
                    style: {
                        visibility: 'hidden',
                    },
                });
            }
        };
        _this.onFinish = function (opts) {
            var _a = _this.props, context = _a.context, name = _a.name;
            if (context && context.onFinish) {
                context.onFinish(opts);
            }
            if (name && opts.name !== name) {
                return;
            }
            _this.setState({
                style: {
                    visibility: 'visible',
                },
            });
        };
        return _this;
    }
    VisibilityManager.prototype.render = function () {
        var children = this.props.children;
        var style = this.state.style;
        return (React.createElement(exports.AnimatorContext.Provider, { value: { onFinish: this.onFinish, onStart: this.onStart } }, children({ style: style })));
    };
    return VisibilityManager;
}(React.Component));
exports.default = VisibilityManager;
exports.withVisibilityManagerContext = function (WrappedComponent) {
    var _a;
    // eslint-disable-next-line react/no-multi-comp
    return _a = /** @class */ (function (_super) {
            __extends(class_1, _super);
            function class_1() {
                return _super !== null && _super.apply(this, arguments) || this;
            }
            class_1.prototype.render = function () {
                var _this = this;
                // WrappedComponent isn't considered to be a proper element for JSX, need to understand why.
                // See: https://github.com/Microsoft/TypeScript/issues/23812
                var CoercedWrappedComponent = WrappedComponent;
                return (React.createElement(exports.AnimatorContext.Consumer, null, function (context) { return (
                // @ts-ignore
                React.createElement(CoercedWrappedComponent, __assign({ context: context }, _this.props))); }));
            };
            return class_1;
        }(React.Component)),
        _a.displayName = "VisibilityManagerContext(" + WrappedComponent.displayName + ")",
        _a;
};
exports.WrappedVisibilityManager = exports.withVisibilityManagerContext(VisibilityManager);
//# sourceMappingURL=index.js.map