"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var popmotion_1 = require("popmotion"); // eslint-disable-line import/no-extraneous-dependencies
var Collector_1 = require("../../Collector");
var MoveRight = function (props) {
    var elementStyler = react_1.useRef();
    return (react_1.default.createElement(Collector_1.default, { data: {
            action: Collector_1.CollectorActions.animation,
            payload: {
                beforeAnimate: function (elements, onFinish) {
                    elementStyler.current = popmotion_1.styler(elements.destination.element);
                    onFinish();
                },
                animate: function (_, onFinish) {
                    popmotion_1.tween({ from: 0, to: { x: 300 }, duration: 1000, ease: popmotion_1.easing.backOut }).start({
                        complete: function () { return onFinish(); },
                        update: elementStyler.current.set,
                    });
                },
            },
        } }, props.children));
};
exports.default = MoveRight;
//# sourceMappingURL=PopmotionMoveRight.js.map