"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var Collector_1 = require("../../Collector");
var math_1 = require("../../lib/math");
var dom_1 = require("../../lib/dom");
var SimpleKeyframe_1 = require("../SimpleKeyframe");
var curves_1 = require("../../lib/curves");
var style_1 = require("../../lib/style");
var duration_1 = require("../../lib/duration");
var CircleExpand = /** @class */ (function (_super) {
    __extends(CircleExpand, _super);
    function CircleExpand() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.renderAnimation = function (data, options) {
            var _a = _this.props, duration = _a.duration, background = _a.background, zIndex = _a.zIndex;
            // Scroll could have changed between unmount and this prepare step, let's recalculate just in case.
            var originBoundingBox = dom_1.recalculateElementBoundingBoxFromScroll(data.origin.elementBoundingBox);
            var minSize = Math.min(originBoundingBox.size.width, originBoundingBox.size.height);
            var fromTargetHypotenuse = math_1.calculateHypotenuse(originBoundingBox.size);
            var fromTargetCenterInViewport = dom_1.calculateElementCenterInViewport(originBoundingBox);
            var viewportCenter = dom_1.calculateWindowCentre();
            var windowDimensions = dom_1.getWindowDimensions();
            var windowHypotenuse = math_1.calculateHypotenuse(windowDimensions);
            var difference = {
                width: viewportCenter.left - fromTargetCenterInViewport.left,
                height: viewportCenter.top - fromTargetCenterInViewport.top,
            };
            var hypotenuseDifference = math_1.calculateHypotenuse(difference);
            var scale = Math.ceil((windowHypotenuse + hypotenuseDifference) / minSize);
            var calculatedDuration = duration === 'dynamic'
                ? duration_1.dynamic(originBoundingBox, {
                    location: { left: 0, top: 0 },
                    size: windowDimensions,
                    raw: {},
                })
                : duration;
            return (React.createElement(SimpleKeyframe_1.default, { style: {
                    zIndex: zIndex,
                    left: originBoundingBox.location.left -
                        (fromTargetHypotenuse - originBoundingBox.size.width) / 2,
                    top: originBoundingBox.location.top -
                        (fromTargetHypotenuse - originBoundingBox.size.height) / 2,
                    width: fromTargetHypotenuse,
                    height: fromTargetHypotenuse,
                    borderRadius: '50%',
                    position: 'absolute',
                    background: background,
                    transition: "transform " + curves_1.accelerate() + " " + calculatedDuration + "ms, opacity " + curves_1.standard() + " " + calculatedDuration /
                        2 + "ms",
                    transform: 'scale(1)',
                    willChange: 'transform',
                    opacity: 1,
                }, keyframes: [
                    {
                        transform: "scale(" + scale + ")",
                    },
                    {
                        transform: "scale(" + scale + ")",
                        opacity: 0,
                    },
                ], step: options.step, onFinish: options.onFinish }));
        };
        _this.beforeAnimate = function (data, onFinish) {
            onFinish();
            return _this.renderAnimation(data, { onFinish: onFinish });
        };
        _this.animate = function (data, onFinish) {
            return _this.renderAnimation(data, { onFinish: onFinish, step: 0 });
        };
        _this.afterAnimate = function (data, onFinish) {
            return _this.renderAnimation(data, { onFinish: onFinish, step: 1 });
        };
        return _this;
    }
    CircleExpand.prototype.render = function () {
        var children = this.props.children;
        return (React.createElement(Collector_1.default, { data: {
                action: Collector_1.CollectorActions.animation,
                payload: {
                    beforeAnimate: this.beforeAnimate,
                    animate: this.animate,
                    afterAnimate: this.afterAnimate,
                },
            } }, children));
    };
    CircleExpand.defaultProps = {
        duration: 'dynamic',
        zIndex: style_1.zIndexStack.circleExpand,
    };
    return CircleExpand;
}(React.Component));
exports.default = CircleExpand;
//# sourceMappingURL=index.js.map