import * as React from 'react';
import { CollectorChildrenProps, AnimationCallback, AnimationData } from '../../Collector';
import { Duration } from '../types';
export interface CircleShrinkProps extends CollectorChildrenProps {
    /**
     * Background, same usage as usual css.
     */
    background: string;
    /**
     * How long the animation should take over {duration}ms.
     */
    duration: Duration;
    /**
     * zIndex to be applied to the moving element.
     */
    zIndex: number;
}
export default class CircleShrink extends React.Component<CircleShrinkProps> {
    static defaultProps: {
        duration: string;
        zIndex: number;
    };
    renderAnimation: (data: AnimationData, options: {
        step?: number | undefined;
        onFinish: () => void;
    }) => JSX.Element;
    beforeAnimate: AnimationCallback;
    animate: AnimationCallback;
    afterAnimate: AnimationCallback;
    render(): JSX.Element;
}
