"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var Collector_1 = require("../../Collector");
var math_1 = require("../../lib/math");
var dom_1 = require("../../lib/dom");
var SimpleKeyframe_1 = require("../SimpleKeyframe");
var curves_1 = require("../../lib/curves");
var style_1 = require("../../lib/style");
var duration_1 = require("../../lib/duration");
var CircleShrink = /** @class */ (function (_super) {
    __extends(CircleShrink, _super);
    function CircleShrink() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.renderAnimation = function (data, options) {
            var _a = _this.props, duration = _a.duration, background = _a.background, zIndex = _a.zIndex;
            var minSize = Math.min(data.destination.elementBoundingBox.size.width, data.destination.elementBoundingBox.size.height);
            var toTargetHypotenuse = math_1.calculateHypotenuse(data.destination.elementBoundingBox.size);
            var toTargetCenterInViewport = dom_1.calculateElementCenterInViewport(data.destination.elementBoundingBox);
            var viewportCenter = dom_1.calculateWindowCentre();
            var windowDimensions = dom_1.getWindowDimensions();
            var windowHypotenuse = math_1.calculateHypotenuse(windowDimensions);
            var difference = {
                width: viewportCenter.left - toTargetCenterInViewport.left,
                height: viewportCenter.top - toTargetCenterInViewport.top,
            };
            var hypotenuseDifference = math_1.calculateHypotenuse(difference);
            var scale = Math.ceil((windowHypotenuse + hypotenuseDifference) / minSize);
            var calculatedDuration = duration === 'dynamic'
                ? duration_1.dynamic(data.destination.elementBoundingBox, {
                    location: { left: 0, top: 0 },
                    size: windowDimensions,
                    raw: {},
                })
                : duration;
            return (React.createElement(SimpleKeyframe_1.default, { style: {
                    zIndex: zIndex,
                    left: data.destination.elementBoundingBox.location.left -
                        (toTargetHypotenuse - data.destination.elementBoundingBox.size.width) / 2,
                    top: data.destination.elementBoundingBox.location.top -
                        (toTargetHypotenuse - data.destination.elementBoundingBox.size.height) / 2,
                    width: toTargetHypotenuse,
                    height: toTargetHypotenuse,
                    borderRadius: '50%',
                    position: 'absolute',
                    background: background,
                    willChange: 'transform',
                    transition: "transform " + curves_1.decelerate() + " " + calculatedDuration + "ms, opacity " + curves_1.standard() + " " + calculatedDuration + "ms",
                    transform: "scale(" + scale + ")",
                }, keyframes: [
                    {
                        transform: 'scale(1)',
                    },
                    {
                        transform: 'scale(1)',
                        opacity: 0,
                    },
                ], step: options.step, onFinish: options.onFinish }));
        };
        _this.beforeAnimate = function (data, onFinish) {
            onFinish();
            return _this.renderAnimation(data, { onFinish: onFinish });
        };
        _this.animate = function (data, onFinish) {
            return _this.renderAnimation(data, { onFinish: onFinish, step: 0 });
        };
        _this.afterAnimate = function (data, onFinish) {
            return _this.renderAnimation(data, { onFinish: onFinish, step: 1 });
        };
        return _this;
    }
    CircleShrink.prototype.render = function () {
        var children = this.props.children;
        return (React.createElement(Collector_1.default, { data: {
                action: Collector_1.CollectorActions.animation,
                payload: {
                    beforeAnimate: this.beforeAnimate,
                    animate: this.animate,
                    afterAnimate: this.afterAnimate,
                },
            } }, children));
    };
    CircleShrink.defaultProps = {
        duration: 'dynamic',
        zIndex: style_1.zIndexStack.circleShrink,
    };
    return CircleShrink;
}(React.Component));
exports.default = CircleShrink;
//# sourceMappingURL=index.js.map