"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var Collector_1 = require("../../Collector");
var math = require("../../lib/math");
var dom_1 = require("../../lib/dom");
var noop_1 = require("../../lib/noop");
var curves_1 = require("../../lib/curves");
var style_1 = require("../../lib/style");
var duration_1 = require("../../lib/duration");
var FadeMove = /** @class */ (function (_super) {
    __extends(FadeMove, _super);
    function FadeMove() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.calculatedDuration = 0;
        _this.renderAnimation = function (data, options) {
            if (options === void 0) { options = {}; }
            var _a = _this.props, timingFunction = _a.timingFunction, duration = _a.duration, zIndex = _a.zIndex;
            // Scroll could have changed between unmount and this prepare step, let's recalculate
            // just in case.
            var fromTargetSizeLocation = dom_1.recalculateElementBoundingBoxFromScroll(data.origin.elementBoundingBox);
            var fromEndXOffset = data.destination.elementBoundingBox.location.left - fromTargetSizeLocation.location.left;
            var fromEndYOffset = data.destination.elementBoundingBox.location.top - fromTargetSizeLocation.location.top;
            _this.calculatedDuration =
                duration === 'dynamic'
                    ? duration_1.dynamic(fromTargetSizeLocation, data.destination.elementBoundingBox)
                    : duration;
            return data.origin.render({
                ref: noop_1.default,
                style: __assign({}, fromTargetSizeLocation.location, { zIndex: zIndex, transition: "transform " + _this.calculatedDuration + "ms " + timingFunction + ", opacity " + _this
                        .calculatedDuration / 2 + "ms " + timingFunction, position: 'absolute', transformOrigin: '0 0', transform: 'translate3d(0, 0, 0) scale3d(1, 1, 1)', opacity: 1, 
                    // Elminate any margins so they don't affect the transition.
                    margin: 0, height: fromTargetSizeLocation.size.height + "px", width: fromTargetSizeLocation.size.width + "px" }, (options.moveToTarget
                    ? {
                        transform: "translate3d(" + fromEndXOffset + "px, " + fromEndYOffset + "px, 0) scale3d(" + math.percentageDifference(data.destination.elementBoundingBox.size.width, fromTargetSizeLocation.size.width) + ", " + math.percentageDifference(data.destination.elementBoundingBox.size.height, fromTargetSizeLocation.size.height) + ", 1)",
                        opacity: 0,
                    }
                    : {})),
            });
        };
        _this.beforeAnimate = function (data, onFinish, setChildProps) {
            setChildProps({
                style: function (prevStyle) { return (__assign({}, prevStyle, { opacity: 0 })); },
            });
            onFinish();
            return _this.renderAnimation(data);
        };
        _this.animate = function (data, onFinish) {
            setTimeout(onFinish, _this.calculatedDuration);
            return _this.renderAnimation(data, { moveToTarget: true });
        };
        _this.afterAnimate = function (_, onFinish, setChildProps) {
            setChildProps({
                style: function (prevStyle) { return (__assign({}, prevStyle, { opacity: 1 })); },
            });
            onFinish();
        };
        return _this;
    }
    FadeMove.prototype.render = function () {
        var children = this.props.children;
        return (React.createElement(Collector_1.default, { data: {
                action: Collector_1.CollectorActions.animation,
                payload: {
                    beforeAnimate: this.beforeAnimate,
                    animate: this.animate,
                    afterAnimate: this.afterAnimate,
                },
            } }, children));
    };
    FadeMove.defaultProps = {
        duration: 'dynamic',
        timingFunction: curves_1.standard(),
        zIndex: style_1.zIndexStack.fadeMove,
    };
    return FadeMove;
}(React.Component));
exports.default = FadeMove;
//# sourceMappingURL=index.js.map