import * as React from 'react';
import { CollectorChildrenProps, AnimationCallback, AnimationData } from '../../Collector';
import { Duration } from '../types';
export interface FocalConcealMoveProps extends CollectorChildrenProps {
    /**
     * How long the animation should take over {duration}ms.
     */
    duration: Duration;
    /**
     * zIndex to be applied to the moving element.
     */
    zIndex: number;
    /**
     * Timing function to be used in the transition.
     */
    timingFunction: string;
}
export default class FocalConcealMove extends React.Component<FocalConcealMoveProps> {
    static defaultProps: {
        duration: string;
        timingFunction: string;
        zIndex: number;
    };
    calculatedDuration: number;
    renderAnimation: (data: AnimationData, options?: {
        moveToTarget?: boolean | undefined;
        fadeOut?: boolean | undefined;
    }) => React.ReactNode;
    beforeAnimate: AnimationCallback;
    animate: AnimationCallback;
    afterAnimate: AnimationCallback;
    render(): JSX.Element;
}
