"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var Collector_1 = require("../../Collector");
var math = require("../../lib/math");
var dom_1 = require("../../lib/dom");
var curves_1 = require("../../lib/curves");
var style_1 = require("../../lib/style");
var duration_1 = require("../../lib/duration");
var noop_1 = require("../../lib/noop");
var Move = /** @class */ (function (_super) {
    __extends(Move, _super);
    function Move() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.abort = noop_1.default;
        _this.beforeAnimate = function (data, onFinish, setChildProps) {
            var _a = _this.props, zIndex = _a.zIndex, useFocalTarget = _a.useFocalTarget, transformX = _a.transformX, transformY = _a.transformY;
            if (useFocalTarget && !data.destination.focalTargetElementBoundingBox) {
                throw new Error("yubaba\n<FocalTarget /> was not found, if you haven't defined one make sure to add one as a descendant of your target Animator.");
            }
            // Scroll could have changed between unmount and this prepare step.
            var originTarget = dom_1.recalculateElementBoundingBoxFromScroll(data.origin.elementBoundingBox);
            var destinationTarget = useFocalTarget && data.destination.focalTargetElementBoundingBox
                ? data.destination.focalTargetElementBoundingBox
                : data.destination.elementBoundingBox;
            var toStartXOffset = transformX
                ? originTarget.location.left - data.destination.elementBoundingBox.location.left
                : 0;
            var toStartYOffset = transformY
                ? originTarget.location.top - data.destination.elementBoundingBox.location.top
                : 0;
            setChildProps({
                style: function (prevStyles) { return (__assign({}, prevStyles, { zIndex: zIndex, opacity: 1, transformOrigin: '0 0', visibility: 'visible', willChange: style_1.combine('transform')(prevStyles.willChange), transform: style_1.combine(prevStyles.transform, '')("translate3d(" + toStartXOffset + "px, " + toStartYOffset + "px, 0) scale3d(" + math.percentageDifference(originTarget.size.width, destinationTarget.size.width) + ", " + math.percentageDifference(originTarget.size.height, destinationTarget.size.height) + ", 1)") })); },
            });
            onFinish();
        };
        _this.animate = function (data, onFinish, setChildProps) {
            var _a = _this.props, duration = _a.duration, timingFunction = _a.timingFunction;
            var calculatedDuration = duration === 'dynamic'
                ? duration_1.dynamic(data.origin.elementBoundingBox, data.destination.elementBoundingBox)
                : duration;
            setChildProps({
                style: function (prevStyles) { return (__assign({}, prevStyles, { transition: style_1.combine("transform " + calculatedDuration + "ms " + timingFunction + ", opacity " + calculatedDuration /
                        2 + "ms " + timingFunction)(prevStyles.transition), transform: 'none' })); },
            });
            var id = window.setTimeout(function () { return onFinish(); }, calculatedDuration);
            _this.abort = function () {
                window.clearTimeout(id);
            };
        };
        return _this;
    }
    Move.prototype.render = function () {
        var children = this.props.children;
        return (React.createElement(Collector_1.default, { data: {
                action: Collector_1.CollectorActions.animation,
                payload: {
                    beforeAnimate: this.beforeAnimate,
                    animate: this.animate,
                    abort: this.abort,
                },
            } }, children));
    };
    Move.defaultProps = {
        duration: 'dynamic',
        timingFunction: curves_1.standard(),
        zIndex: style_1.zIndexStack.move,
        useFocalTarget: false,
        transformX: true,
        transformY: true,
    };
    return Move;
}(React.Component));
exports.default = Move;
//# sourceMappingURL=index.js.map