"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var Collector_1 = require("../../Collector");
var curves_1 = require("../../lib/curves");
var style_1 = require("../../lib/style");
var duration_1 = require("../../lib/duration");
var noop_1 = require("../../lib/noop");
var Reveal = /** @class */ (function (_super) {
    __extends(Reveal, _super);
    function Reveal() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.abort = noop_1.default;
        _this.beforeAnimate = function (data, onFinish, setChildProps) {
            var _a = _this.props.offset, topOffset = _a[0], rightOffset = _a[1], bottomOffset = _a[2], leftOffset = _a[3];
            var right = data.destination.elementBoundingBox.size.width -
                data.origin.elementBoundingBox.size.width +
                rightOffset;
            var bottom = data.destination.elementBoundingBox.size.height -
                data.origin.elementBoundingBox.size.height +
                bottomOffset;
            setChildProps({
                style: function (prevStyles) {
                    return data.origin.elementBoundingBox
                        ? __assign({}, prevStyles, { clipPath: "inset(" + topOffset + "px " + right + "px " + bottom + "px " + leftOffset + "px)", opacity: 1, visibility: 'visible', willChange: style_1.combine('clip-path')(prevStyles.willChange) }) : undefined;
                },
            });
            onFinish();
        };
        _this.animate = function (data, onFinish, setChildProps) {
            var _a = _this.props, timingFunction = _a.timingFunction, duration = _a.duration;
            var calculatedDuration = duration === 'dynamic'
                ? duration_1.dynamic(data.origin.elementBoundingBox, data.destination.elementBoundingBox)
                : duration;
            setChildProps({
                style: function (prevStyles) { return (__assign({}, prevStyles, { clipPath: 'inset(0px)', transition: style_1.combine("clip-path " + calculatedDuration + "ms " + timingFunction)(prevStyles.transition) })); },
            });
            var id = window.setTimeout(function () { return onFinish(); }, calculatedDuration);
            _this.abort = function () {
                window.clearTimeout(id);
            };
        };
        return _this;
    }
    Reveal.prototype.render = function () {
        var children = this.props.children;
        return (React.createElement(Collector_1.default, { data: {
                action: Collector_1.CollectorActions.animation,
                payload: {
                    beforeAnimate: this.beforeAnimate,
                    animate: this.animate,
                    abort: this.abort,
                },
            } }, children));
    };
    Reveal.defaultProps = {
        duration: 'dynamic',
        timingFunction: curves_1.standard(),
        offset: [0, 0, 0, 0],
    };
    return Reveal;
}(React.Component));
exports.default = Reveal;
//# sourceMappingURL=index.js.map