import { ElementBoundingBox } from '../dom';
export declare function getScreenSizeWeight(width: number): number;
/**
 * Will return a number bounded around how far the element had to travel which will
 * always be a whole number.
 *
 * According to google via https://material.io/design/motion/speed.html#duration:
 * - Small (travelled 0-5% of the screen) = 100ms
 * - Medium (travelled 6-39% of the screen) = 250ms expand, 200ms collapse
 * - Large (travelled 40%+ of the screen) = 300ms expand, 250ms collapse
 *
 * If the origin is smaller than the destination, it will use expand time.
 * Else it will use collapse time.
 *
 * @param origin ElementBoundingBox
 * @param destination ElementBoundingBox
 */
export declare function dynamic(origin: ElementBoundingBox, destination: ElementBoundingBox): number;
