import * as React from 'react';
import { SupplyDataHandler, SupplyRenderChildrenHandler, SupplyRefHandler, CollectorChildrenAsFunction, CollectorData } from '../Collector';
import * as store from '../lib/animatorStore';
import { AnimatorProps, AnimatorState } from './types';
export default class Animator extends React.PureComponent<AnimatorProps, AnimatorState> {
    static displayName: string;
    static defaultProps: {
        onFinish: () => void;
        timeToWaitForNextAnimator: number;
        container: HTMLElement;
        name: string;
    };
    state: AnimatorState;
    animating: boolean;
    unmounting: boolean;
    element: HTMLElement | null;
    focalTargetElement: HTMLElement | null;
    renderChildren: CollectorChildrenAsFunction;
    data: CollectorData[];
    abortAnimations: () => void;
    componentDidMount(): void;
    getSnapshotBeforeUpdate(prevProps: AnimatorProps): store.AnimatorData | null;
    componentDidUpdate(prevProps: AnimatorProps, _: AnimatorState, DOMSnapshot: store.AnimatorData | null): void;
    componentWillUnmount(): void;
    notifyVisibilityManagerAnimationsAreFinished(): void;
    delayedClearStore(): void;
    snapshotDOMData(action?: 'store' | 'return'): store.AnimatorData | null;
    executeAnimations: (DOMSnapshot?: store.AnimatorData | null) => void;
    setRef: SupplyRefHandler;
    setTargetRef: SupplyRefHandler;
    setReactNode: SupplyRenderChildrenHandler;
    setData: SupplyDataHandler;
    render(): JSX.Element;
}
export declare const WrappedAnimator: {
    new (props: Readonly<Pick<Pick<AnimatorProps, "children" | "context" | "in" | "triggerSelfKey"> & Partial<Pick<AnimatorProps, "name" | "onFinish" | "timeToWaitForNextAnimator" | "container">> & Partial<Pick<{
        onFinish: () => void;
        timeToWaitForNextAnimator: number;
        container: HTMLElement;
        name: string;
    }, never>>, "children" | "name" | "in" | "triggerSelfKey" | "onFinish" | "timeToWaitForNextAnimator" | "container">>): {
        render(): JSX.Element;
        context: any;
        setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<Pick<Pick<AnimatorProps, "children" | "context" | "in" | "triggerSelfKey"> & Partial<Pick<AnimatorProps, "name" | "onFinish" | "timeToWaitForNextAnimator" | "container">> & Partial<Pick<{
            onFinish: () => void;
            timeToWaitForNextAnimator: number;
            container: HTMLElement;
            name: string;
        }, never>>, "children" | "name" | "in" | "triggerSelfKey" | "onFinish" | "timeToWaitForNextAnimator" | "container">>) => {} | Pick<{}, K> | null) | Pick<{}, K> | null, callback?: (() => void) | undefined): void;
        forceUpdate(callBack?: (() => void) | undefined): void;
        readonly props: Readonly<Pick<Pick<AnimatorProps, "children" | "context" | "in" | "triggerSelfKey"> & Partial<Pick<AnimatorProps, "name" | "onFinish" | "timeToWaitForNextAnimator" | "container">> & Partial<Pick<{
            onFinish: () => void;
            timeToWaitForNextAnimator: number;
            container: HTMLElement;
            name: string;
        }, never>>, "children" | "name" | "in" | "triggerSelfKey" | "onFinish" | "timeToWaitForNextAnimator" | "container">> & Readonly<{
            children?: React.ReactNode;
        }>;
        state: Readonly<{}>;
        refs: {
            [key: string]: React.ReactInstance;
        };
    };
    new (props: Pick<Pick<AnimatorProps, "children" | "context" | "in" | "triggerSelfKey"> & Partial<Pick<AnimatorProps, "name" | "onFinish" | "timeToWaitForNextAnimator" | "container">> & Partial<Pick<{
        onFinish: () => void;
        timeToWaitForNextAnimator: number;
        container: HTMLElement;
        name: string;
    }, never>>, "children" | "name" | "in" | "triggerSelfKey" | "onFinish" | "timeToWaitForNextAnimator" | "container">, context?: any): {
        render(): JSX.Element;
        context: any;
        setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<Pick<Pick<AnimatorProps, "children" | "context" | "in" | "triggerSelfKey"> & Partial<Pick<AnimatorProps, "name" | "onFinish" | "timeToWaitForNextAnimator" | "container">> & Partial<Pick<{
            onFinish: () => void;
            timeToWaitForNextAnimator: number;
            container: HTMLElement;
            name: string;
        }, never>>, "children" | "name" | "in" | "triggerSelfKey" | "onFinish" | "timeToWaitForNextAnimator" | "container">>) => {} | Pick<{}, K> | null) | Pick<{}, K> | null, callback?: (() => void) | undefined): void;
        forceUpdate(callBack?: (() => void) | undefined): void;
        readonly props: Readonly<Pick<Pick<AnimatorProps, "children" | "context" | "in" | "triggerSelfKey"> & Partial<Pick<AnimatorProps, "name" | "onFinish" | "timeToWaitForNextAnimator" | "container">> & Partial<Pick<{
            onFinish: () => void;
            timeToWaitForNextAnimator: number;
            container: HTMLElement;
            name: string;
        }, never>>, "children" | "name" | "in" | "triggerSelfKey" | "onFinish" | "timeToWaitForNextAnimator" | "container">> & Readonly<{
            children?: React.ReactNode;
        }>;
        state: Readonly<{}>;
        refs: {
            [key: string]: React.ReactInstance;
        };
    };
    displayName: string;
    contextType?: React.Context<any> | undefined;
};
