import React, { useRef } from 'react';
import { styler, tween, easing } from 'popmotion'; // eslint-disable-line import/no-extraneous-dependencies
import Collector, { CollectorActions } from '../../Collector';
var MoveRight = function (props) {
    var elementStyler = useRef();
    return (React.createElement(Collector, { data: {
            action: CollectorActions.animation,
            payload: {
                beforeAnimate: function (elements, onFinish) {
                    elementStyler.current = styler(elements.destination.element);
                    onFinish();
                },
                animate: function (_, onFinish) {
                    tween({ from: 0, to: { x: 300 }, duration: 1000, ease: easing.backOut }).start({
                        complete: function () { return onFinish(); },
                        update: elementStyler.current.set,
                    });
                },
            },
        } }, props.children));
};
export default MoveRight;
//# sourceMappingURL=PopmotionMoveRight.js.map