var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import * as React from 'react';
import Collector, { CollectorActions, } from '../../Collector';
import { calculateHypotenuse } from '../../lib/math';
import { calculateWindowCentre, calculateElementCenterInViewport, getWindowDimensions, } from '../../lib/dom';
import SimpleKeyframe from '../SimpleKeyframe';
import { standard, decelerate } from '../../lib/curves';
import { zIndexStack } from '../../lib/style';
import { dynamic } from '../../lib/duration';
var CircleShrink = /** @class */ (function (_super) {
    __extends(CircleShrink, _super);
    function CircleShrink() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.renderAnimation = function (data, options) {
            var _a = _this.props, duration = _a.duration, background = _a.background, zIndex = _a.zIndex;
            var minSize = Math.min(data.destination.elementBoundingBox.size.width, data.destination.elementBoundingBox.size.height);
            var toTargetHypotenuse = calculateHypotenuse(data.destination.elementBoundingBox.size);
            var toTargetCenterInViewport = calculateElementCenterInViewport(data.destination.elementBoundingBox);
            var viewportCenter = calculateWindowCentre();
            var windowDimensions = getWindowDimensions();
            var windowHypotenuse = calculateHypotenuse(windowDimensions);
            var difference = {
                width: viewportCenter.left - toTargetCenterInViewport.left,
                height: viewportCenter.top - toTargetCenterInViewport.top,
            };
            var hypotenuseDifference = calculateHypotenuse(difference);
            var scale = Math.ceil((windowHypotenuse + hypotenuseDifference) / minSize);
            var calculatedDuration = duration === 'dynamic'
                ? dynamic(data.destination.elementBoundingBox, {
                    location: { left: 0, top: 0 },
                    size: windowDimensions,
                    raw: {},
                })
                : duration;
            return (React.createElement(SimpleKeyframe, { style: {
                    zIndex: zIndex,
                    left: data.destination.elementBoundingBox.location.left -
                        (toTargetHypotenuse - data.destination.elementBoundingBox.size.width) / 2,
                    top: data.destination.elementBoundingBox.location.top -
                        (toTargetHypotenuse - data.destination.elementBoundingBox.size.height) / 2,
                    width: toTargetHypotenuse,
                    height: toTargetHypotenuse,
                    borderRadius: '50%',
                    position: 'absolute',
                    background: background,
                    willChange: 'transform',
                    transition: "transform " + decelerate() + " " + calculatedDuration + "ms, opacity " + standard() + " " + calculatedDuration + "ms",
                    transform: "scale(" + scale + ")",
                }, keyframes: [
                    {
                        transform: 'scale(1)',
                    },
                    {
                        transform: 'scale(1)',
                        opacity: 0,
                    },
                ], step: options.step, onFinish: options.onFinish }));
        };
        _this.beforeAnimate = function (data, onFinish) {
            onFinish();
            return _this.renderAnimation(data, { onFinish: onFinish });
        };
        _this.animate = function (data, onFinish) {
            return _this.renderAnimation(data, { onFinish: onFinish, step: 0 });
        };
        _this.afterAnimate = function (data, onFinish) {
            return _this.renderAnimation(data, { onFinish: onFinish, step: 1 });
        };
        return _this;
    }
    CircleShrink.prototype.render = function () {
        var children = this.props.children;
        return (React.createElement(Collector, { data: {
                action: CollectorActions.animation,
                payload: {
                    beforeAnimate: this.beforeAnimate,
                    animate: this.animate,
                    afterAnimate: this.afterAnimate,
                },
            } }, children));
    };
    CircleShrink.defaultProps = {
        duration: 'dynamic',
        zIndex: zIndexStack.circleShrink,
    };
    return CircleShrink;
}(React.Component));
export default CircleShrink;
//# sourceMappingURL=index.js.map