var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
import * as React from 'react';
import { css } from 'emotion';
import Collector, { CollectorActions, } from '../../Collector';
import { recalculateElementBoundingBoxFromScroll } from '../../lib/dom';
import noop from '../../lib/noop';
import { standard } from '../../lib/curves';
import { zIndexStack } from '../../lib/style';
import { dynamic } from '../../lib/duration';
var FocalConcealMove = /** @class */ (function (_super) {
    __extends(FocalConcealMove, _super);
    function FocalConcealMove() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.calculatedDuration = 0;
        _this.renderAnimation = function (data, options) {
            if (options === void 0) { options = {}; }
            if (!data.origin.focalTargetElementBoundingBox) {
                throw new Error("yubaba\n<FocalTarget /> was not found, if you haven't defined one make sure to add one as a descendant of your target Animator.");
            }
            var _a = _this.props, duration = _a.duration, timingFunction = _a.timingFunction, zIndex = _a.zIndex;
            // Scroll could have changed between unmount and this prepare step.
            var fromTargetSizeLocation = recalculateElementBoundingBoxFromScroll(data.origin.elementBoundingBox);
            _this.calculatedDuration =
                duration === 'dynamic'
                    ? dynamic(fromTargetSizeLocation, data.destination.elementBoundingBox)
                    : duration;
            return data.origin.render({
                ref: noop,
                style: {
                    zIndex: zIndex,
                    opacity: options.fadeOut ? 0 : 1,
                    transition: "transform " + _this.calculatedDuration + "ms " + timingFunction + ", height " + _this.calculatedDuration + "ms " + timingFunction + ", width " + _this.calculatedDuration + "ms " + timingFunction + ", opacity " + _this
                        .calculatedDuration / 2 + "ms " + timingFunction,
                    position: 'absolute',
                    transformOrigin: '0 0',
                    willChange: 'transform, height, width',
                    top: fromTargetSizeLocation.location.top,
                    left: fromTargetSizeLocation.location.left,
                    height: options.moveToTarget
                        ? data.destination.elementBoundingBox.size.height
                        : fromTargetSizeLocation.size.height,
                    width: options.moveToTarget
                        ? data.destination.elementBoundingBox.size.width
                        : fromTargetSizeLocation.size.width,
                    overflow: 'hidden',
                    transform: options.moveToTarget
                        ? "translate3d(" + (data.destination.elementBoundingBox.location.left -
                            data.origin.elementBoundingBox.location.left) + "px, " + (data.destination.elementBoundingBox
                            .location.top - data.origin.elementBoundingBox.location.top) + "px, 0)"
                        : undefined,
                },
                className: options.moveToTarget
                    ? css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n            > * {\n              transition: transform ", "ms ", ";\n              transform: translate3d(\n                -", "px,\n                -", "px,\n                0\n              );\n            }\n          "], ["\n            > * {\n              transition: transform ", "ms ", ";\n              transform: translate3d(\n                -", "px,\n                -", "px,\n                0\n              );\n            }\n          "])), _this.calculatedDuration, timingFunction, data.origin.focalTargetElementBoundingBox.location.left - data.origin.elementBoundingBox.location.left, data.origin.focalTargetElementBoundingBox.location.top - data.origin.elementBoundingBox.location.top) : undefined,
            });
        };
        _this.beforeAnimate = function (data, onFinish) {
            onFinish();
            return _this.renderAnimation(data);
        };
        _this.animate = function (data, onFinish) {
            setTimeout(onFinish, _this.calculatedDuration);
            return _this.renderAnimation(data, { moveToTarget: true });
        };
        _this.afterAnimate = function (data, onFinish, setChildProps) {
            setChildProps({
                style: function () { return ({
                    opacity: 1,
                }); },
            });
            setTimeout(onFinish, 100);
            return _this.renderAnimation(data, { moveToTarget: true, fadeOut: true });
        };
        return _this;
    }
    FocalConcealMove.prototype.render = function () {
        var children = this.props.children;
        return (React.createElement(Collector, { data: {
                action: CollectorActions.animation,
                payload: {
                    beforeAnimate: this.beforeAnimate,
                    animate: this.animate,
                    afterAnimate: this.afterAnimate,
                },
            } }, children));
    };
    FocalConcealMove.defaultProps = {
        duration: 'dynamic',
        timingFunction: standard(),
        zIndex: zIndexStack.concealMove,
    };
    return FocalConcealMove;
}(React.Component));
export default FocalConcealMove;
var templateObject_1;
//# sourceMappingURL=index.js.map