var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import * as React from 'react';
import { css } from 'emotion';
import Collector, { CollectorActions, } from '../../Collector';
import { standard } from '../../lib/curves';
import { combine } from '../../lib/style';
import { dynamic } from '../../lib/duration';
var FocalReveal = /** @class */ (function (_super) {
    __extends(FocalReveal, _super);
    function FocalReveal() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.beforeAnimate = function (data, onFinish, setChildProps) {
            if (!data.destination.focalTargetElementBoundingBox) {
                throw new Error("yubaba\n<FocalTarget /> was not found, if you haven't defined one make sure to add one as a descendant of your target Animator.");
            }
            var _a = _this.props, childrenTransformX = _a.childrenTransformX, childrenTransformY = _a.childrenTransformY, useClipPath = _a.useClipPath;
            var offsetChildrenX = childrenTransformX
                ? data.destination.focalTargetElementBoundingBox.location.left -
                    data.destination.elementBoundingBox.location.left
                : 0;
            var offsetChildrenY = childrenTransformY
                ? data.destination.focalTargetElementBoundingBox.location.top -
                    data.destination.elementBoundingBox.location.top
                : 0;
            var revealStyles = useClipPath
                ? {
                    clipPath: "inset(0 " + (data.destination.elementBoundingBox.size.width -
                        data.destination.focalTargetElementBoundingBox.size.width) + "px " + (data.destination
                        .elementBoundingBox.size.height -
                        data.destination.focalTargetElementBoundingBox.size.height) + "px 0)",
                }
                : {
                    height: data.destination.focalTargetElementBoundingBox.size.height,
                    width: data.destination.focalTargetElementBoundingBox.size.width,
                };
            setChildProps({
                style: function (prevStyles) {
                    return data.destination.focalTargetElementBoundingBox
                        ? __assign({}, prevStyles, revealStyles, { opacity: 1, visibility: 'visible', willChange: combine('height, width, clip-path')(prevStyles.willChange), overflow: 'hidden' }) : undefined;
                },
                className: function () {
                    return data.destination.focalTargetElementBoundingBox
                        ? css({
                            '> *': {
                                transform: "translate3d(-" + offsetChildrenX + "px, -" + offsetChildrenY + "px, 0)",
                            },
                        })
                        : undefined;
                },
            });
            onFinish();
        };
        _this.animate = function (data, onFinish, setChildProps) {
            var _a = _this.props, timingFunction = _a.timingFunction, duration = _a.duration, useClipPath = _a.useClipPath;
            var calculatedDuration = duration === 'dynamic'
                ? dynamic(data.origin.elementBoundingBox, data.destination.elementBoundingBox)
                : duration;
            var revealStyles = useClipPath
                ? {
                    clipPath: 'inset(0 0 0 0)',
                }
                : {
                    height: data.destination.elementBoundingBox.size.height,
                    width: data.destination.elementBoundingBox.size.width,
                };
            setChildProps({
                style: function (prevStyles) { return (__assign({}, prevStyles, revealStyles, { transition: combine("height " + calculatedDuration + "ms " + timingFunction + ", width " + calculatedDuration + "ms " + timingFunction + ", clip-path " + calculatedDuration + "ms " + timingFunction)(prevStyles.transition) })); },
                className: function () {
                    return css({
                        '> *': {
                            transform: "translate3d(0, 0, 0)",
                            transition: "transform " + calculatedDuration + "ms " + timingFunction,
                        },
                    });
                },
            });
            setTimeout(function () { return onFinish(); }, calculatedDuration);
        };
        return _this;
    }
    FocalReveal.prototype.render = function () {
        var children = this.props.children;
        return (React.createElement(Collector, { data: {
                action: CollectorActions.animation,
                payload: {
                    beforeAnimate: this.beforeAnimate,
                    animate: this.animate,
                },
            } }, children));
    };
    FocalReveal.defaultProps = {
        duration: 'dynamic',
        timingFunction: standard(),
        childrenTransformX: true,
        childrenTransformY: true,
    };
    return FocalReveal;
}(React.Component));
export default FocalReveal;
//# sourceMappingURL=index.js.map