import * as React from 'react';
import { CollectorChildrenProps, AnimationCallback } from '../../Collector';
import { Duration } from '../types';
export interface RevealProps extends CollectorChildrenProps {
    /**
     * Takes either "dynamic" or a number in ms.
     * How long the animation should take over {duration}ms.
     * Defaults to "dynamic".
     */
    duration: Duration;
    /**
     * Timing function to be used in the transition.
     */
    timingFunction: string;
    /**
     * This will increase (or decrease) the size of the clip-path box.
     * Use with caution.
     * [top, right, bottom, left]
     */
    offset: [number, number, number, number];
}
export default class Reveal extends React.Component<RevealProps> {
    static defaultProps: {
        duration: string;
        timingFunction: string;
        offset: number[];
    };
    abort: () => void;
    beforeAnimate: AnimationCallback;
    animate: AnimationCallback;
    render(): JSX.Element;
}
