import * as React from 'react';
import { CollectorChildrenAsFunction } from '../../Collector';
import { ReshapingContainerProps } from '../ReshapingContainer';
interface RevealReshapingContainerProps extends ReshapingContainerProps {
    /**
     * Children as function.
     * Will receive an object with className, style, and ref.
     */
    children: CollectorChildrenAsFunction;
}
export default class RevealReshapingContainer extends React.PureComponent<RevealReshapingContainerProps> {
    static defaultProps: {
        as: string;
    };
    componentDidMount(): void;
    /**
     * We're using this to increase the clip-path box of the Reveal animation so the children contents
     * line up with the parent container in this component.
     */
    getInversePaddingParts(): [number, number, number, number] | undefined;
    render(): JSX.Element;
}
export {};
