var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import * as React from 'react';
import { WrappedAnimator as Animator } from '../../Animator';
import ReshapingContainer from '../ReshapingContainer';
import Reveal from '../Reveal';
var RevealReshapingContainer = /** @class */ (function (_super) {
    __extends(RevealReshapingContainer, _super);
    function RevealReshapingContainer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RevealReshapingContainer.prototype.componentDidMount = function () {
        if ((process.env.NODE_ENV === 'development' && this.props.padding.indexOf('em') >= 0) ||
            this.props.padding.indexOf('%') >= 0) {
            throw new Error("Only px values are supported for props.padding in " + ReshapingContainer.name);
        }
    };
    /**
     * We're using this to increase the clip-path box of the Reveal animation so the children contents
     * line up with the parent container in this component.
     */
    RevealReshapingContainer.prototype.getInversePaddingParts = function () {
        var parts = this.props.padding.split(' ').map(function (p) { return -Number(p.replace('px', '')); });
        switch (parts.length) {
            case 0:
                return undefined;
            case 1:
                parts.push(parts[0]);
                parts.push(parts[0]);
                parts.push(parts[0]);
                break;
            case 2:
                parts.push(parts[0]);
                parts.push(parts[1]);
                break;
            case 3:
                parts.push(parts[1]);
                break;
            case 4:
            default:
                break;
        }
        return parts;
    };
    RevealReshapingContainer.prototype.render = function () {
        var _this = this;
        var _a = this.props, children = _a.children, duration = _a.duration, timingFunction = _a.timingFunction, triggerKey = _a.triggerKey;
        return (React.createElement(ReshapingContainer, __assign({}, this.props), function (reshaping) { return (React.createElement(Animator, { triggerSelfKey: triggerKey },
            React.createElement(Reveal, { duration: duration, offset: _this.getInversePaddingParts(), timingFunction: timingFunction }, function (anim) {
                return children(__assign({}, anim, { style: __assign({}, anim.style, reshaping.style) }));
            }))); }));
    };
    RevealReshapingContainer.defaultProps = ReshapingContainer.defaultProps;
    return RevealReshapingContainer;
}(React.PureComponent));
export default RevealReshapingContainer;
//# sourceMappingURL=index.js.map