import * as React from 'react';
import { CollectorChildrenProps, AnimationCallback } from '../../Collector';
export interface SwipeProps extends CollectorChildrenProps {
    /**
     * Background, same usage as usual css.
     */
    background: string;
    /**
     * Direction the swipe will be heading towards.
     */
    direction: 'left' | 'right' | 'up' | 'down';
    /**
     * How long the animation should take over {duration}ms.
     */
    duration: number;
    /**
     * zIndex to be applied to the moving element.
     */
    zIndex: number;
}
export default class Swipe extends React.Component<SwipeProps> {
    static defaultProps: {
        duration: number;
        zIndex: number;
    };
    renderAnimation: (options: {
        step: number | undefined;
        onFinish: () => void;
    }) => JSX.Element;
    beforeAnimate: AnimationCallback;
    animate: AnimationCallback;
    afterAnimate: AnimationCallback;
    render(): JSX.Element;
}
