var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import * as React from 'react';
import Collector, { CollectorActions, } from '../../Collector';
import SimpleKeyframe from '../SimpleKeyframe';
import { standard, decelerate } from '../../lib/curves';
import { zIndexStack } from '../../lib/style';
var Swipe = /** @class */ (function (_super) {
    __extends(Swipe, _super);
    function Swipe() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.renderAnimation = function (options) {
            var _a = _this.props, duration = _a.duration, background = _a.background, direction = _a.direction, zIndex = _a.zIndex;
            var directionMap = {
                left: '100%, 0, 0',
                right: '-100%, 0, 0',
                down: '0, -100%, 0',
                up: '0, 100%, 0',
            };
            return (React.createElement(SimpleKeyframe, { step: options.step, style: {
                    zIndex: zIndex,
                    position: 'fixed',
                    top: 0,
                    left: 0,
                    right: 0,
                    bottom: 0,
                    background: background,
                    transform: "translate3d(" + directionMap[direction] + ")",
                    transition: "transform " + decelerate() + " " + duration + "ms, opacity " + standard() + " " + duration + "ms",
                }, keyframes: [
                    {
                        transform: 'translate3d(0, 0, 0)',
                    },
                    {
                        transform: 'translate3d(0, 0, 0)',
                        opacity: 0,
                    },
                ], onFinish: options.onFinish }));
        };
        _this.beforeAnimate = function (_, onFinish) {
            onFinish();
            return _this.renderAnimation({ onFinish: onFinish, step: undefined });
        };
        _this.animate = function (_, onFinish) {
            return _this.renderAnimation({ onFinish: onFinish, step: 0 });
        };
        _this.afterAnimate = function (_, onFinish) {
            return _this.renderAnimation({ onFinish: onFinish, step: 1 });
        };
        return _this;
    }
    Swipe.prototype.render = function () {
        var children = this.props.children;
        return (React.createElement(Collector, { data: {
                action: CollectorActions.animation,
                payload: {
                    beforeAnimate: this.beforeAnimate,
                    animate: this.animate,
                    afterAnimate: this.afterAnimate,
                },
            } }, children));
    };
    Swipe.defaultProps = {
        duration: 500,
        zIndex: zIndexStack.swipe,
    };
    return Swipe;
}(React.Component));
export default Swipe;
//# sourceMappingURL=index.js.map