export declare function getDocumentScroll(): {
    scrollTop: number;
    scrollLeft: number;
};
export interface ElementBoundingBoxOpts {
    useOffsetSize?: boolean;
}
export interface ElementBoundingBox {
    size: {
        width: number;
        height: number;
    };
    location: {
        left: number;
        top: number;
    };
    raw: {
        rect: ClientRect | DOMRect;
        scrollTop: number;
        scrollLeft: number;
    };
}
export declare function getElementBoundingBox(element: HTMLElement, options?: ElementBoundingBoxOpts): ElementBoundingBox;
export declare function calculateElementCenterInViewport(elementBoundingBox: ElementBoundingBox): {
    top: number;
    left: number;
};
export declare function getWindowDimensions(): {
    width: number;
    height: number;
};
export declare function calculateWindowCentre(): {
    left: number;
    top: number;
};
export declare function recalculateElementBoundingBoxFromScroll(elementBoundingBox: ElementBoundingBox): ElementBoundingBox;
