var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
export function getDocumentScroll() {
    var scrollTop = document.documentElement && document.documentElement.scrollTop
        ? document.documentElement.scrollTop
        : document.body && document.body.scrollTop;
    var scrollLeft = document.documentElement && document.documentElement.scrollLeft
        ? document.documentElement.scrollLeft
        : document.body && document.body.scrollLeft;
    return {
        scrollTop: scrollTop || 0,
        scrollLeft: scrollLeft || 0,
    };
}
export function getElementBoundingBox(element, options) {
    if (options === void 0) { options = {}; }
    var rect = element.getBoundingClientRect();
    var _a = getDocumentScroll(), scrollLeft = _a.scrollLeft, scrollTop = _a.scrollTop;
    return {
        size: {
            width: options.useOffsetSize ? element.offsetWidth : rect.width,
            height: options.useOffsetSize ? element.offsetHeight : rect.height,
        },
        location: {
            left: rect.left + scrollLeft,
            top: rect.top + scrollTop,
        },
        raw: {
            rect: rect,
            scrollTop: scrollTop,
            scrollLeft: scrollLeft,
        },
    };
}
export function calculateElementCenterInViewport(elementBoundingBox) {
    return {
        top: elementBoundingBox.location.top + Math.ceil(elementBoundingBox.size.width / 2),
        left: elementBoundingBox.location.left - Math.ceil(elementBoundingBox.size.height / 2),
    };
}
export function getWindowDimensions() {
    return {
        width: window.innerWidth,
        height: window.innerHeight,
    };
}
export function calculateWindowCentre() {
    return {
        left: Math.ceil(window.innerWidth / 2),
        top: Math.ceil(window.innerHeight / 2),
    };
}
export function recalculateElementBoundingBoxFromScroll(elementBoundingBox) {
    var _a = getDocumentScroll(), scrollTop = _a.scrollTop, scrollLeft = _a.scrollLeft;
    var scrollTopDiff = scrollTop - elementBoundingBox.raw.scrollTop;
    var scrollLeftDiff = scrollLeft - elementBoundingBox.raw.scrollLeft;
    return __assign({}, elementBoundingBox, { location: {
            top: elementBoundingBox.location.top + scrollTopDiff,
            left: elementBoundingBox.location.left + scrollLeftDiff,
        } });
}
//# sourceMappingURL=dom.js.map